diff -urnp dropbear-2019.78/svr-chansession.c dropbear-2019.78-patched/svr-chansession.c
*** dropbear-2019.78/svr-chansession.c	Wed Mar 27 14:15:23 2019
--- dropbear-2019.78-patched/svr-chansession.c	Fri Feb 14 19:26:02 2020
*************** void svr_chansess_checksignal(void) {
*** 142,153 ****
  static void sesssigchild_handler(int UNUSED(dummy)) {
  	struct sigaction sa_chld;
  
- 	const int saved_errno = errno;
  
  	TRACE(("enter sigchld handler"))
  
  	/* Make sure that the main select() loop wakes up */
  	while (1) {
  		/* isserver is just a random byte to write. We can't do anything
  		about an error so should just ignore it */
  		if (write(ses.signal_pipe[1], &ses.isserver, 1) == 1
--- 142,153 ----
  static void sesssigchild_handler(int UNUSED(dummy)) {
  	struct sigaction sa_chld;
  
  
  	TRACE(("enter sigchld handler"))
  
  	/* Make sure that the main select() loop wakes up */
  	while (1) {
+ 		
  		/* isserver is just a random byte to write. We can't do anything
  		about an error so should just ignore it */
  		if (write(ses.signal_pipe[1], &ses.isserver, 1) == 1
*************** static void sesssigchild_handler(int UNU
*** 156,168 ****
  		}
  	}
  
  	sa_chld.sa_handler = sesssigchild_handler;
  	sa_chld.sa_flags = SA_NOCLDSTOP;
  	sigemptyset(&sa_chld.sa_mask);
! 	sigaction(SIGCHLD, &sa_chld, NULL);
  	TRACE(("leave sigchld handler"))
  
  	errno = saved_errno;
  }
  
  /* send the exit status or the signal causing termination for a session */
--- 156,185 ----
  		}
  	}
  
+ /* Because SGI leaves zombie processes behind we need to clean up and exit(1) */
+ #if defined(__sgi)
+ 
+ 	sa_chld.sa_handler = sesssigchild_handler;
+ 
+ 	sigemptyset(&sa_chld.sa_mask);
+     sa_chld.sa_flags = SA_RESTART | SA_NOCLDSTOP;
+     if (sigaction(SIGCHLD, &sa_chld, 0) == -1) {
+       perror(0);
+       exit(1);
+     }
+ 
+   perror(0);
+   exit(1);
+ 
+ #else
  	sa_chld.sa_handler = sesssigchild_handler;
  	sa_chld.sa_flags = SA_NOCLDSTOP;
  	sigemptyset(&sa_chld.sa_mask);
!     sigaction(SIGCHLD, &sa_chld, NULL);
  	TRACE(("leave sigchld handler"))
  
  	errno = saved_errno;
+ #endif
  }
  
  /* send the exit status or the signal causing termination for a session */
*************** static int sessioncommand(struct Channel
*** 696,702 ****
  
  	/* take global command into account */
  	if (svr_opts.forced_command) {
! 		chansess->original_command = chansess->cmd ? : m_strdup("");
  		chansess->cmd = m_strdup(svr_opts.forced_command);
  	} else {
  		/* take public key option 'command' into account */
--- 713,719 ----
  
  	/* take global command into account */
  	if (svr_opts.forced_command) {
! //		chansess->original_command = chansess->cmd ? : m_strdup("");
  		chansess->cmd = m_strdup(svr_opts.forced_command);
  	} else {
  		/* take public key option 'command' into account */